/*****************************************************
CVAVR V2.05
Chip type               : ATtiny13A
AVR Core Clock frequency: 9,600000 MHz
*****************************************************/
#include <tiny13a.h>

#define s_step 376

unsigned char ADC1=200,ADC2;
unsigned char tmr0,tmr1,tmr2,a=70,mst;
bit LoBat,cntfb;



flash unsigned char s_table [s_step/2]=
{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,16,17,18,19,20,21,
22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,38,39,40,41,42,43,
44,45,46,47,48,49,50,51,52,53,54,54,55,56,57,58,59,60,61,62,63,
64,65,66,67,68,69,69,70,71,72,73,74,75,76,76,77,78,79,80,81,82,
82,83,84,85,86,86,87,88,89,89,90,91,92,92,93,94,95,95,96,97,97,
98,99,99,100,101,101,102,103,103,104,105,105,106,106,107,108,108,109,109,110,110,
111,111,112,112,113,113,114,114,115,115,116,116,117,117,117,118,118,119,119,119,120,
120,121,121,121,122,122,122,122,123,123,123,124,124,124,124,125,125,125,125,125,126,
126,126,126,126,126,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127};

void t0_cfg()
{
 TCCR0A=1<<COM0A1|1<<COM0B1|1<<COM0B0|1<<WGM00; 
 TCCR0B=1; OCR0A=0xff/2-5;OCR0B=OCR0A+10;  //phase correct pwm, top 0xff, no prsc
 TIMSK0|=1<<OCIE0A;
}
void ports_cfg()
{
 PORTB=0b11101000;
 DDRB =0b11100011;
}
void adc_cfg()
{
 ADMUX|=1<<REFS0|1<<ADLAR|1;
 ADCSRA|=1<<ADEN|1<<ADSC|7;
}
void hv_cnt()
{
 if((cntfb)&&(!tmr2))
 {
 if(ADC2<200){if(a<100-5)a+=5;} //205V
 else if(ADC2>230){if(a>5)a-=5;}//236V
 cntfb=0;
 } 
}
void adc_scan()
{
if(!ADCSRA.ADSC)
{    
  if (ADMUX&1)
 {
  ADMUX &= 0b11110000; ADMUX |= 2;  
  ADC1=ADCH; 
  ADCSRA |= 1<<ADSC; 
 }  
   else
 {
  ADMUX &= 0b11110000; ADMUX |= 1;  
  ADC2=ADCH; hv_cnt(); 
  ADCSRA |= 1<<ADSC; 
 }
}
}
void bat_detect()
{
 if(ADC1>200){tmr1=50;}   //12.5V
 else if (ADC1<150){LoBat=1;tmr0=50;}//9.3V
 if(!tmr1) {LoBat=1;tmr0=tmr2=50;TCCR0A=0;a=50;} 
 if(!tmr0) {LoBat=0;TCCR0A=1<<COM0A1|1<<COM0B1|1<<COM0B0|1<<WGM00;}      
 
}
void exiti_cfg()
{
 GIMSK|=1<<PCIE;
 PCMSK|=1<<PCINT3;   
}

interrupt [TIM0_COMPA] void t0_cmpa()
{
#define dtv 4
 static unsigned char c=0, tmp_table=0;
 static bit d=1,p=1;
 
 tmp_table=((unsigned int)s_table [c]*mst)/100;

 if((d)&&(p))                                          
 {
    OCR0A=0x80+tmp_table;
    if(OCR0A<=0xff-dtv){OCR0B=OCR0A+dtv;}else{OCR0B=OCR0A=0xff;}
    if(c<s_step/2-1){c++;} else {d=0;if(tmr0)tmr0--;}  
 } 
    else if((!d)&&(p))
    {
        OCR0A=0x80+tmp_table;
        if(OCR0A<=0xff-dtv){OCR0B=OCR0A+dtv;}else{OCR0A=OCR0B=0xff;}
        if(c){c--;} else {d=1;p=0;if(tmr1)tmr1--;}
    }
        else if((d)&&(!p)) 
        {
         OCR0B=0x7f-tmp_table;
         if(OCR0B>=dtv){OCR0A=OCR0B-dtv;}else{OCR0A=OCR0B=0;}
         if(c<s_step/2-1){c++;} else {d=0;if(tmr2)tmr2--;}
        }
            else
            {
             OCR0B=0x7f-tmp_table;
             if(OCR0B>=dtv){OCR0A=OCR0B-dtv;}else{OCR0A=OCR0B=0;}
             if(c){c--;}else {d=1;p=1; cntfb=1;mst=a; }
            } 
   #asm ("wdr")
}            
interrupt [PC_INT0] void pin_change_isr(void)
{
 if(!PINB.3){tmr2=255;a=0;}
}

void main(void)
{
ports_cfg();
t0_cfg();
adc_cfg();
exiti_cfg();


// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
#pragma optsize-
WDTCR=0x18;
WDTCR=0x08;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei")

while (1)
      {
       adc_scan();       
       bat_detect();  
      }
}
